<?php

namespace NoccyLabs\Plugin\Extension;

use NoccyLabs\Plugin\PluginManager;
use NoccyLabs\Plugin\PluginInstance;

abstract class AbstractExtension
{

    protected $manager;

    protected $plugin;

    public function onRegister()
    {}

    public function onLoad()
    {}

    public function getDataPath($path)
    {
        $dataRoot = $this->manager->getDataDirectory();
        if (empty($dataRoot)) {
            throw new \Exception("No data directory assigned in PluginManager");
        }
        $pluginName = $this->plugin->getName();
        $dataPath = $dataRoot."/".$pluginName."/".$path;
        return $dataPath;
    }

    public function setPluginManager(PluginManager $pluginManager)
    {
        $this->manager = $pluginManager;
    }

    public function setPluginInstance(PluginInstance $pluginInstance)
    {
        $this->plugin = $pluginInstance;
    }
}

