<?php

namespace NoccyLabs\Plugin\Loader;

abstract class AbstractLoader
{
    protected $root;

    /**
     * Create an autoloader stub
     *
     */
    abstract public function createAutoloader($type,$ns,$path);

    /**
     * Return a fully qualified path for the specified file, relative to the root
     * of the plugin directory, archive etc. 
     *
     * @param string
     * @return string
     */
    abstract public function getPath($path);

    public function getManifest()
    {
        $json = file_get_contents($this->getPath("plugin.json"));
        $manifest = json_decode($json);
        return $manifest;
    }


    abstract public static function test($path);


    public static function create($path)
    {
        $inst = new static;
        $inst->root = $path;
        return $inst;
    }

    public function getRoot()
    {
        return $this->root;
    }

}

